



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SPOJ DQUERY:D-query</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SPOJ DQUERY:D-query</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 20:55:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>主席树/树状数组。给一个区间，多次询问[l,r]内有多少个不重复的元素。每个前缀都建线段树，询问直接r的[l,r]就可以了。（似乎对主席树有一点了解了？。。。话说spoj好高级的样子。。。</p>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
#define REP(i,s,t) for(int i=s;i&lt;=t;i++)<br />
#define dwn(i,s,t) for(int i=s;i&gt;=t;i--)<br />
#define clr(x,c) memset(x,c,sizeof(x))<br />
int read(){<br />
	int x=0;char c=getchar();<br />
	while(!isdigit(c)) c=getchar();<br />
	while(isdigit(c)) x=x*10+c-'0',c=getchar();<br />
	return x;<br />
}<br />
const int nmax=30005;<br />
const int inf=0x7f7f7f7f;<br />
struct node{<br />
	node *l,*r;int sum;<br />
};<br />
node nodes[nmax*25],*pt=nodes,*root[nmax];<br />
int a[nmax],b[nmax],vis[nmax*40];<br />
node* build(int l,int r){<br />
	node* op=pt++;op-&gt;sum=0;<br />
	if(l==r) return op;<br />
	int mid=(l+r)&gt;&gt;1;<br />
	op-&gt;l=build(l,mid);op-&gt;r=build(mid+1,r);<br />
	return op;<br />
}<br />
node* update(int p,int add,node* t,int l,int r){<br />
	node* op=pt++;op-&gt;sum=t-&gt;sum+add;<br />
	if(l==r) return op;<br />
	int mid=(l+r)&gt;&gt;1;<br />
	if(p&lt;=mid) op-&gt;r=t-&gt;r,op-&gt;l=update(p,add,t-&gt;l,l,mid);<br />
	else op-&gt;l=t-&gt;l,op-&gt;r=update(p,add,t-&gt;r,mid+1,r);<br />
	return op;<br />
}<br />
int query(int tl,int tr,int l,int r,node* t){<br />
	if(tl&lt;=l&amp;&amp;tr&gt;=r) return t-&gt;sum;<br />
	int ans=0,mid=(l+r)&gt;&gt;1;<br />
	if(tl&lt;=mid) ans+=query(tl,tr,l,mid,t-&gt;l);<br />
	if(tr&gt;mid) ans+=query(tl,tr,mid+1,r,t-&gt;r);<br />
	return ans;<br />
}<br />
int main(){<br />
	int n,m;<br />
	while(scanf("%d",&amp;n)!=EOF){<br />
		pt=nodes;clr(vis,0);<br />
		REP(i,1,n) a[i]=read();

		root[0]=build(1,n);<br />
		REP(i,1,n){<br />
			node* t=update(i,1,root[i-1],1,n);<br />
			if(vis[a[i]]) root[i]=update(vis[a[i]],-1,t,1,n);<br />
			else root[i]=t;<br />
			vis[a[i]]=i;<br />
		}

		m=read();<br />
		REP(i,1,m){<br />
			int s=read(),t=read();<br />
			printf("%d\n",query(s,t,1,n,root[t]));<br />
		}<br />
	}<br />
	return 0;<br />
}
</pre>
</div>
<p>　　</p>
<div><a href="http://acm.hust.edu.cn/vjudge/problem/32356/origin" rel="external nofollow noreferrer">D-query</a></div>
<div>
<table>
<tbody>
<tr>
<td><strong>Time Limit:</strong>&nbsp;227MS</td>
<td>&nbsp;</td>
<td><strong>Memory Limit:</strong>&nbsp;1572864KB</td>
<td>&nbsp;</td>
<td><strong>64bit IO Format:</strong>&nbsp;%lld &amp; %llu</td>
</tr>
</tbody>
</table>
</div>
<p><a href="http://acm.hust.edu.cn/vjudge/problem/submit/32356" rel="external nofollow noreferrer">Submit</a>&nbsp;<a href="http://acm.hust.edu.cn/vjudge/status/#OJId=SPOJ&amp;probNum=DQUERY" rel="external nofollow noreferrer">Status</a></p>
<div>
<p>Description</p>
<div>
<div>
<table>
<tbody>
<tr>
<td><a href="http://www.spoj.com/problems/DQUERY/en/" rel="external nofollow noreferrer">English</a></td>
<td><a href="http://www.spoj.com/problems/DQUERY/vn/" rel="external nofollow noreferrer">Vietnamese</a></td>
</tr>
</tbody>
</table>
<p>Given a sequence of n numbers a<sub>1</sub>, a<sub>2</sub>, ..., a<sub>n</sub>&nbsp;and a number of d-queries. A d-query is a pair (i, j) (1 &le; i &le; j &le; n). For each d-query (i, j), you have to return the number of distinct elements in the subsequence a<sub>i</sub>, a<sub>i+1</sub>, ..., a<sub>j</sub>.</p>
<h3>Input</h3>
<ul><li>Line 1: n (1 &le; n &le; 30000).</li>
<li>Line 2: n numbers a<sub>1</sub>, a<sub>2</sub>, ..., a<sub>n</sub>&nbsp;(1 &le; a<sub>i</sub>&nbsp;&le; 10<sup>6</sup>).</li>
<li>Line 3: q (1 &le; q &le; 200000), the number of d-queries.</li>
<li>In the next q lines, each line contains 2 numbers i, j representing a d-query (1 &le; i &le; j &le; n).</li></ul>
<h3>Output</h3>
<ul><li>For each d-query (i, j), print the number of distinct elements in the subsequence a<sub>i</sub>, a<sub>i+1</sub>, ..., a<sub>j</sub>&nbsp;in a single line.</li></ul>
<h3>Example</h3>
<pre class="prettyprint linenums"><strong>Input</strong><br />
5<br />
1 1 2 1 3<br />
3<br />
1 5<br />
2 4<br />
3 5

<strong>Output</strong><br />
3<br />
2<br />
3
</pre>
</div>
</div>
</div>
<div>
<p>Hint</p>
<div>
<table>
<tbody>
<tr>
<td>Added by:</td>
<td><a href="http://www.spoj.com/users/paulmcvn" rel="external nofollow noreferrer">Duc</a></td>
</tr>
<tr>
<td>Date:</td>
<td>2008-10-26</td>
</tr>
<tr>
<td>Time limit:</td>
<td>0.227s</td>
</tr>
<tr>
<td>Source limit:</td>
<td>50000B</td>
</tr>
<tr>
<td>Memory limit:</td>
<td>1536MB</td>
</tr>
<tr>
<td>Cluster:</td>
<td><a href="http://www.spoj.com/clusters/" rel="external nofollow noreferrer">Cube (Intel G860)</a></td>
</tr>
<tr>
<td>Languages:</td>
<td>All except: ERL JS NODEJS PERL 6 VB.net</td>
</tr>
<tr>
<td>Resource:</td>
<td>&copy;&nbsp;<a href="http://vnoi.info/" rel="external nofollow noreferrer">VNOI</a></td>
</tr>
</tbody>
</table>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8myyg68.html">java小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvnw4y9.html">利用 Django REST framework 编写 RESTful API</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96egy3q.html">System&period;Net&period;WebException &colon; The remote server returned an error&colon; &lpar;415&rpar; UNSUPPORTED MEDIA TYPE</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935o6rq.html">javafx之CSS初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vjwr38.html">数据库的应用&mdash;&mdash;直接从内存中读取osg节点 （转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6lrlq.html">WPF中实现根据拼音查找汉字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde4ngq.html">JavaSE思维导图&lpar;五&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjv079.html">POJ 3654 &amp;amp&semi;amp&semi; ZOJ 2936 &amp;amp&semi;amp&semi; HDU 2723 Electronic Document Security（模拟）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mej6z0q.html">Toast用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4v6g8.html">深入浅出理解python 装饰器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk34yd8.html">Dynamics CRM模拟OAuth请求获得Token后在外部调用Web API</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pep1j8.html">关于Android Studio 3&period;2 运行应用时提示 &OpenCurlyDoubleQuote;Instant Run requires that the platform corresponding to your target device &lpar;Android 7&period;0 &lpar;Nougat&rpar;&rpar; is installed&period;&rdquo; 的说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1416q.html">connector for python实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdoer09.html">Linux安装npm并打包前端代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90reel39.html">org&period;apache&period;catalina&period;core&period;DefaultInstanceManager cannot be cast to org&period;apache&period;tomcat&period;InstanceManager</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxmnxq.html">Android应用内实现视频播放--腾讯浏览服务（TBS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gvl7eq.html">scrapy通过修改配置文件发送状态邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvmdnk8.html">cocos2d-x C&plus;&plus; &lpar;iOS&rpar;集成第三方微信分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eygxj9.html">把MacBook里的电影导入到iPad</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jyrwr8.html">java（一）IntelliJ和eclipse环境下的Hello World</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mny72rq.html">VB6-操作数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wgl3wq.html">Spark Streaming揭秘 Day25 StreamingContext和JobScheduler启动源码详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1kerj9.html">1030&period; Travel Plan &lpar;30&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wg4dvq.html">FragmentActivity和Activity的具体区别在哪里</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd6e5d8.html">我的WebX框架学习总结与心得分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y7rk0q.html">C&num; - Lambda 表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wgo3oq.html">sql之表的表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e13d1e9.html">unity手游之聊天SDK集成与使用二</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1kwp69.html">Deferred Shading（延迟渲染）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj7zk79.html">第一好用的时间 日期插件&lpar;Adding a Timepicker to jQuery UI Datepicker&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
